// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function [rt0,rP0]=fgetImpact(t1,t2,P1,P2)
    a=(P2-P1)/(t2-t1);
    b=(P2*t1-P1*t2)/(t1-t2);
    t0=-b(3)/a(3);
    P0=b+t0*a;
    
    rt0=t0;
    rP0=P0;
endfunction

// Test

//P1=[1;1;1];
//P2=[-1;-1;-1];
//
//[rt0,rP0]=fgetImpact(1,2,P1,P2);
//
//disp(rt0);
//disp(rP0);

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function [rIx,rP1,rP2]=fgetImpactInterval(phData)
    atIx=0;
    rP1=zeros(1,3);
    rP2=zeros(1,3);
  
    for ix=1:(size(phData,"c")-1)
        if ((phData(3,ix)>0) & (phData(3,ix+1)<0)) then
            atIx=ix;
            break;
        end
    end
    
    rIx=atIx;
    
    if (atIx>0) then
        rP1=phData(1:3,ix);
        rP2=phData(1:3,ix+1);
    end
endfunction

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function tImpact=fgetImpactTime(t0,t_end,steps,atIx)
    tImpact=atIx*(t_end-t0)/(steps-1);
endfunction

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function rTheta=fgetProjAngel(v)
    v1=v(1);
    v2=v(2);
    
    if (v1<>0) then
        rTheta=atan(v2,v1);
    elseif (v2>0) then
        rTheta=%pi/2;
    elseif (v2<0) then
        rTheta=%pi*3/2;
    else
        rTheta=0;
    end
endfunction

// Test

//vc=180/%pi;
//
//vnull=[100;101;100];
//Theta=fgetProjAngel(vnull);
//disp(Theta*vc);
//
//vnull=[-100;101;100];
//Theta=fgetProjAngel(vnull);
//disp(Theta*vc);
//
//vnull=[-100;-101;100];
//Theta=fgetProjAngel(vnull);
//disp(Theta*vc);
//
//vnull=[100;-101;100];
//Theta=fgetProjAngel(vnull);
//disp(Theta*vc);

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function rfilt=ffilt(x)
    [nr,nc]= size(x);
    
    if (nc >1) then
        rfilt=x;
        return;
    end
    
    y=x;
    for Ix=1:nr
        if (abs(y(Ix,1))<0.1) then
             y(Ix,1)=0;
        end
    end
    
    rfilt=y;
endfunction

//x1=[1;2;0.001];
//disp(ffilt(x1));
//x2=[1,3;2,3;0.001,3];
//disp(ffilt(x2));

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
